<?php
namespace Advanced_Themer_Bricks;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class AT__Ajax{
    private static function add_non_duplicate_entries($arr1, $arr2, $property){
        if(isset($arr1) && is_array($arr1) && !empty($arr1)){
            foreach ($arr1 as $objectA) {
                $idA = $objectA[$property];
                $found = false;
            
                // Check if the object with the same id exists in arrayB
                if(isset($arr2) && is_array($arr2) && !empty($arr2)){
                    foreach ($arr2 as $objectB) {
                        $idB = $objectB[$property];
                        if ($idA === $idB) {
                            $found = true;
                            break;
                        }
                    }
                }
            
                // If the object with the same name was not found in arrayB, add it
                if (!$found) {
                    $arr2[] = $objectA;
                }
            }
        }

        return $arr2;
    }

    public static function import_advanced_options_callback() {
        if (!current_user_can('manage_options')) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }


        // Verify nonce
        $nonce = isset($_POST['nonce']) ? sanitize_text_field($_POST['nonce']) : '';
    
        if (!wp_verify_nonce($nonce, 'export_advanced_options_nonce')) {
            wp_send_json_error("Invalid nonce, please refresh the page and try again.");
            wp_die();
        }

            
        if ( ! isset( $_FILES['file']['tmp_name'] ) ) { 
            wp_send_json_error( 'File not uploaded.' ); 
        } 

        $temp_path = $_FILES['file']['tmp_name']; 
        $checked_data = $_POST['checked_data'];
        $overwrite = $_POST['overwrite'];
        

        if ($checked_data === null) {
            wp_send_json_error('Invalid checked data.');
        }

        $json_file = AT__Helpers::read_file_contents($temp_path);

        if ($json_file !== false){

            $data = json_decode($json_file, true);

            if ($data === null) {
                wp_send_json_error('Invalid JSON file.');
            }

            global $wpdb;

            // AT Settings
            $pos = strpos($checked_data, 'at-theme-settings');
            if( $pos && isset($data['at_settings']) && is_array($data['at_settings']) ){

                // Theme Settings
                
                $wpdb->query("DELETE FROM $wpdb->options WHERE option_name LIKE '%bricks-advanced-themer%' AND option_name NOT LIKE '%_variables_repeater%'");
        
                foreach ($data['at_settings'] as $option_name => $option_value) {
                    if (is_array($option_value)) {
                        $option_value = maybe_serialize($option_value);
                    }

                    $wpdb->insert($wpdb->options, array('option_name' => $option_name, 'option_value' => $option_value));

                }

                // Builder settings
                
                if(isset($data['at_settings_builder']) && $data['at_settings_builder'] && is_array($data['at_settings_builder']) && !empty($data['at_settings_builder'])){
                    update_option('bricks_advanced_themer_builder_settings', $data['at_settings_builder']);
                }
            }


            // Global Variables
            $pos = strpos($checked_data, 'global-variables');
            if( $pos && isset($data['global-variables']) && is_array($data['global-variables']) ){
                
                $global_variables = get_option('bricks_global_variables');

                if( !isset($global_variables) || !$global_variables || !is_array($global_variables) || empty($global_variables) || $overwrite === true ) {
                    $global_variables = [];
                }

                $global_variables = self::add_non_duplicate_entries($data['global-variables'], $global_variables, 'id');

                if(is_array($global_variables) && !empty($global_variables)){
                    update_option('bricks_global_variables', $global_variables);
                }
            }

            if( $pos && isset($data['global-variables-categories']) && is_array($data['global-variables-categories']) ){
                
                $global_variables_categories = get_option('bricks_global_variables_categories');

                if( !isset($global_variables_categories) || !$global_variables_categories || !is_array($global_variables_categories) || empty($global_variables_categories) || $overwrite === true ) {
                    $global_variables_categories = [];
                }

                $global_variables_categories = self::add_non_duplicate_entries($data['global-variables-categories'], $global_variables_categories, 'id');

                if(is_array($global_variables_categories) && !empty($global_variables_categories)){
                    update_option('bricks_global_variables_categories', $global_variables_categories);
                }
            }


            // Global Classes
            $pos = strpos($checked_data, 'global-classes');
            if( $pos && isset($data['global-classes']) && is_array($data['global-classes']) ){
                
                $global_classes = get_option('bricks_global_classes');

                if( !isset($global_classes) || !$global_classes || !is_array($global_classes) || empty($global_classes) || $overwrite === true ) {
                    $global_classes = [];
                }

                $global_classes = self::add_non_duplicate_entries($data['global-classes'], $global_classes, 'name');

                if(is_array($global_classes) && !empty($global_classes)){
                    update_option('bricks_global_classes', $global_classes);
                }
                
            }

            // Global Classes Categories
            if( $pos && isset($data['global-classes-categories']) && is_array($data['global-classes-categories']) ){
                
                $global_classes_categories = get_option('bricks_global_classes_categories');

                if( !isset($global_classes_categories) || !$global_classes_categories || !is_array($global_classes_categories) || empty($global_classes_categories) || $overwrite === true ) {
                    $global_classes_categories = [];
                }

                $global_classes_categories = self::add_non_duplicate_entries($data['global-classes-categories'], $global_classes_categories, 'id');

                if(is_array($global_classes_categories) && !empty($global_classes_categories)){
                    update_option('bricks_global_classes_categories', $global_classes_categories);
                }
                
            }


            // Theme Styles
            $pos = strpos($checked_data, 'theme-styles');
            if( $pos && isset($data['theme_styles']) && is_array($data['theme_styles']) ){
                
                $theme_styles = get_option('bricks_theme_styles');

                if( !isset($theme_styles) || !$theme_styles || !is_array($theme_styles) || empty($theme_styles) || $overwrite === true ) {
                    $theme_styles = [];
                }

                foreach ($data['theme_styles'] as $objectA => $valueA) {
                    $nameA = $objectA;
                    $foundThemeStyle = false;
                
                    // Check if the object with the same name exists in arrayB
                    foreach ($theme_styles as $objectB => $valueB) {
                        $nameB = $objectB;
                        if ($nameA === $nameB) {
                            $foundThemeStyle = true;
                            break;
                        }
                    }
                
                    // If the object with the same name was not found in arrayB, add it
                    if (!$foundThemeStyle) {
                        $theme_styles[$objectA] = $valueA;
                    }
                }

                if(is_array($theme_styles) && !empty($theme_styles)){
                    update_option('bricks_theme_styles', $theme_styles);
                }
                
            }

            // Global Colors
            $pos = strpos($checked_data, 'global-colors');
            if( $pos && isset($data['global-colors']) && is_array($data['global-colors']) ){
                
                $global_colors = get_option('bricks_color_palette');

                if( !isset($global_colors) || !$global_colors || !is_array($global_colors) || empty($global_colors) || $overwrite === true ) {
                    $global_colors = [];
                }

                $global_colors = self::add_non_duplicate_entries($data['global-colors'], $global_colors, 'id');

                if(is_array($global_colors) && !empty($global_colors)){
                    update_option('	bricks_color_palette', $global_colors);
                }
                
            }

    
            wp_send_json_success($data);
        }


        wp_die(); // Required for AJAX callback 
    }
    
	public static function save_full_access_ajax_function(){

        if (!current_user_can('manage_options') ) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }

        // Verify nonce
        if ( ! wp_verify_nonce( $_POST['nonce'], 'openai_ajax_nonce' ) ) {
            die( 'Invalid nonce' );
        }
     
        $option = get_option('bricks_advanced_themer_builder_settings');
		$fullAccess = isset($_POST['fullAccess']) ? $_POST['fullAccess'] : false;

		if($fullAccess === false){
			wp_send_json_error('Data error');
		}

        $data = $fullAccess;
        $option['full_access'] = $data;
        update_option('bricks_advanced_themer_builder_settings', $option);

        wp_send_json_success($option);
    }

    public static function save_custom_components_ajax_function() {
        if (!current_user_can('manage_options')) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }
    
        // Verify nonce
        if (!wp_verify_nonce($_POST['nonce'], 'openai_ajax_nonce')) {
            die('Invalid nonce');
        }
    
        // Get existing options
        $option = get_option('bricks_advanced_themer_builder_settings');
        
        // Get posted data
        $customComponentsElements = isset($_POST['customComponentsElements']) ? stripslashes_deep($_POST['customComponentsElements']) : false;
        $customComponentsCategories = isset($_POST['customComponentsCategories']) ? stripslashes_deep($_POST['customComponentsCategories']) : false;
    
        // Validate data
        if ($customComponentsElements === false || $customComponentsCategories === false) {
            wp_send_json_error('Data error');
        }
    
        // Decode JSON data
        $customComponentsElements = json_decode($customComponentsElements, true);
        $customComponentsCategories = json_decode($customComponentsCategories, true);
    
        // Update options
        $option['custom_components_elements'] = $customComponentsElements;
        $option['custom_components_categories'] = $customComponentsCategories;
        
        // Save updated options
        update_option('bricks_advanced_themer_builder_settings', $option);
    
        wp_send_json_success($option);
    }

    /**
     * Save the content to the child theme's style.css file
     */
    private static function save_child_theme_css($css_content) {
        // Initialize the WordPress filesystem
        global $wp_filesystem;
        
        if (empty($wp_filesystem)) {
            require_once(ABSPATH . 'wp-admin/includes/file.php');
            WP_Filesystem();
        }
    
        // Get the child theme directory
        $child_theme_path = get_stylesheet_directory(); // Child theme directory path
    
        // Define the full path to the style.css file
        $style_css_path = $child_theme_path . '/style.css';
    
        // Check if the file exists and is writable
        if ($wp_filesystem->exists($style_css_path) && $wp_filesystem->is_writable($style_css_path)) {

            // Remove slashes for single quotes
            $css_content = stripslashes($css_content);

            // Write the new content to style.css
            if ($wp_filesystem->put_contents($style_css_path, $css_content, FS_CHMOD_FILE)) {
                return true; // File updated successfully
            } else {
                return false; // Failed to write to file
            }
        } else {
            return false; // File does not exist or is not writable
        }
    }
    private static function save_css_to_uploads($id, $css_content) {
        // Ensure the ID and CSS content are valid strings
        if (empty($id)) {
            return new \WP_Error('invalid_data', 'Invalid ID.');
        }
    
        // Get the upload directory
        $upload_dir = wp_upload_dir();
        $css_dir = trailingslashit($upload_dir['basedir']) . 'advanced-themer/css/';
        
        // Use the WordPress filesystem API
        global $wp_filesystem;
        
        if (empty($wp_filesystem)) {
            require_once(ABSPATH . 'wp-admin/includes/file.php');
            WP_Filesystem();
        }
    
        // Check if filesystem was initialized correctly
        if (!WP_Filesystem()) {
            return new WP_Error('filesystem_error', 'Could not initialize the filesystem.');
        }
    
        // Create the directory if it doesn't exist
        if (!wp_mkdir_p($css_dir)) {
            return new WP_Error('mkdir_failed', 'Failed to create the necessary directories.');
        }
    
        // Set the file path
        $file_path = $css_dir . 'at-' . sanitize_file_name($id) . '.css';
    
        // Remove existing file if it exists
        if ($wp_filesystem->exists($file_path)) {
            $wp_filesystem->delete($file_path);
        }
    
        // Write the new CSS file
        if (!$wp_filesystem->put_contents($file_path,  AT__Helpers::sanitize_css_content($css_content), FS_CHMOD_FILE)) {
            return new WP_Error('file_write_error', 'Failed to write the CSS file.');
        }
    
        return $file_path; // Return the path of the saved file
    }
    
    private static function remove_css_from_uploads($id) {
        // Ensure the ID is valid
        if (empty($id)) {
            return new \WP_Error('invalid_data', 'Invalid ID.');
        }
    
        // Get the upload directory
        $upload_dir = wp_upload_dir();
        $css_dir = trailingslashit($upload_dir['basedir']) . 'advanced-themer/css/';
        
        // Use the WordPress filesystem API
        global $wp_filesystem;
        if (empty($wp_filesystem)) {
            require_once(ABSPATH . 'wp-admin/includes/file.php');
            WP_Filesystem();
        }
    
        // Check if filesystem was initialized correctly
        if (!WP_Filesystem()) {
            return new \WP_Error('filesystem_error', 'Could not initialize the filesystem.');
        }
    
        // Set the file path
        $file_path = $css_dir . 'at-' . sanitize_file_name($id) . '.css';

        // Check if the file exists, and then delete it
        if ($wp_filesystem->exists($file_path)) {
            if ($wp_filesystem->delete($file_path)) {
                return true; // Successfully deleted
            } else {
                return new \WP_Error('delete_failed', 'Failed to delete the CSS file.');
            }
        }
    }

    private static function filter_non_ajax_elements($elements) {
        $filtered_elements = array_filter($elements, function($element) {
            return isset($element['saveMethod']) && $element['saveMethod'] == 'ajax';
        });

        return array_values($filtered_elements);
    }

    private static function filter_wpcodebox_elements($elements) {
        $filtered_elements = array_filter($elements, function($element) {
            return isset($element['category']) && strpos($element['category'], 'wpcodebox') === 0;
        });

        return array_values($filtered_elements);
    }
    
    public static function save_advanced_css_ajax_function(){
        if (!current_user_can('manage_options')) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }
    
        // Verify nonce
        if ( ! wp_verify_nonce( $_POST['nonce'], 'openai_ajax_nonce' ) ) {
            die( 'Invalid nonce' );
        }
        
        $option = get_option('bricks_global_settings');
        $at_option = get_option('bricks_advanced_themer_builder_settings');
        $advanced_css = $_POST['advanced_css'];
        
        if(!isset($advanced_css) || !is_array($advanced_css)){
            return new \WP_Error('ajax_error', 'No data in POST.');
        }
        
        $items_to_save = self::filter_non_ajax_elements($advanced_css);

        // Update at options
        foreach ($items_to_save as $key => $item){
            
            // Remove item
            if(isset($item['removed']) && $item['removed'] == true){
                unset($items_to_save[$key]);
                if(!isset($item['typeLabel']) || $item['typeLabel'] != "recipe"){
                    self::remove_css_from_uploads($item['id']);
                }
                continue;
            }

            // Global CSS
            if($item['id'] === "at-global-css" && isset($item['hasChanged']) && $item['hasChanged'] == true){
                $option['customCss'] = $item['contentCss'];
                update_option('bricks_global_settings', $option);
                continue;
            }

            // Child
            if($item['id'] === "at-child-css" && isset($item['hasChanged']) && $item['hasChanged'] == true){
                $result = self::save_child_theme_css($item['contentCss']);
                
                if (!$result) {
                    wp_send_json_error('Failed to update child theme style.css');
                }
                continue;
            }

            // Custom files
            if($item['category'] == "custom" && isset($item['hasChanged'], $item['typeLabel'], $item['contentCss']) && $item['hasChanged'] == true && $item['typeLabel'] != "recipe" && $item['contentCss'] && $item['contentCss'] != ''){
                self::save_css_to_uploads($item['id'], $item['contentCss']);
            }

        }
        
        $at_option['advanced_css'] = $items_to_save;
        update_option('bricks_advanced_themer_builder_settings', $at_option);

        //WPCodeBox
        $items_to_save = self::filter_wpcodebox_elements($advanced_css);
        if(isset($items_to_save) && is_array($items_to_save) && !empty($items_to_save)){
            if (class_exists('\Wpcb2\Api\Api') && class_exists('\Wpcb2\Repository\SnippetRepository') && class_exists('\Wpcb2\Service\SnippetToResponseMapper')) {
                $wpcbApi = new \Wpcb2\Api\Api();
                foreach ($items_to_save as $key => $item){
                    // Remove item
                    if(isset($item['removed']) && $item['removed'] == true){
                        $wpcbApi->deleteSnippet($item['id']);
                        continue;
                    }
        
                    // Update
                    if(isset($item['hasChanged']) && $item['hasChanged'] == true){
                        $type = $item['type'] === 'css' ? 'contentCss' : 'contentSass';
                        $fieldsMap = [
                            $type          => 'code',
                            'codeType'     => ['value' => $type],
                            'label'        => 'title',
                            'message'      => 'description',
                            'status'       => 'enabled',
                        ];
    
                        $snippetRepository = new \Wpcb2\Repository\SnippetRepository();
                        $postMapper = new \Wpcb2\Service\SnippetToResponseMapper();
    
                        $internalSnippet = $snippetRepository->getSnippet($item['id']);
                        $data = $postMapper->mapSnippetToResponse($internalSnippet);

    
                        foreach ($fieldsMap as $itemKey => $dataKey) {
                            if (isset($item[$itemKey])) {
                                $data[$dataKey] = stripslashes($item[$itemKey]);
                            }
                        }

                        try {
                            // Update data through API
                            $wpcbApi->updateSnippet($item['id'], $data);

                            // Enable Snippet through Repository
                            if(isset($data['enabled'])){
                                $snippetRepository->updateSnippet($item['id'], [
                                    'enabled' => (int) $data['enabled']
                                ]);
                            }
                        } catch (\Exception $e) {
                            echo "Error updating snippet: " . $e->getMessage();
                            wp_send_json_error($e->getMessage());
                        }
                    }
                }
                // Proceed with using $wpcbApi as needed
            } else {
                // Handle the error or load the class manually
                wp_send_json_error('WPCodeBox Classes not found! Upgrade WPCodeBox!');
            }
        }
    
    }

    public static function generated_html_ajax_function() {
        if (!current_user_can('manage_options')) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }
    
        // Verify nonce
        if (!wp_verify_nonce($_POST['nonce'], 'openai_ajax_nonce')) {
            die('Invalid nonce');
        }
    
        // Get existing options
        $element = $_POST['element'];
        $html = \Bricks\Frontend::render_element($element);
    
        wp_send_json_success($html);
    }   

    public static function generated_html_multiple_elements_ajax_function() {
        if (!current_user_can('manage_options')) {
            wp_send_json_error('You don\'t have permission to perform this action.');
        }
    
        // Verify nonce
        if (!wp_verify_nonce($_POST['nonce'], 'openai_ajax_nonce')) {
            die('Invalid nonce');
        }
    
        // Get existing options
        $elements = $_POST['elements'];
        $html = \Bricks\Frontend::render_data($elements, 'content');
    
        wp_send_json_success($html);
    }   
}