<?php
/**
 * Function to Send Bricks Form Data to Webhook
 */
function pro_bricks_form_to_webhook($form) {
    $data = $form->get_fields();

    // The Bricks Form ID is the last part of the CSS ID
    // So if a form has a CSS ID of bricks-element-fszxsr, then the form ID is fszxsr
    $formId = $data['formId'];

    // Function to clean form array
    function cleanFormArray($array) {
        if (is_array($array)) {
            return implode(', ', array_filter($array));
        }
        return $array;
    }

    // Replace this comment with the description of the form
    // Copy and paste the IF block below to add custom action for other forms
    if ($formId == 'brxe-afmchd') {
        // Clean up any array fields
        foreach ($data as $key => $value) {
            $data[$key] = cleanFormArray($value);
        }

        $webhook_url = "https://some-web-hook-url-goes-here";
        
        $curl = curl_init($webhook_url);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, [
            'Content-Type: application/x-www-form-urlencoded'
        ]);

        $result = curl_exec($curl);
        $http_status = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        curl_close($curl);

        // Set result of action
        if ($http_status >= 200 && $http_status < 300) {
            $form->set_result([
                'action' => 'webhook_submission',
                'type'   => 'success',
                'message' => esc_html__('Form submitted successfully', 'bricks'),
            ]);
        } else {
            $form->set_result([
                'action' => 'webhook_submission',
                'type'   => 'danger',
                'message' => esc_html__('Webhook submission failed', 'bricks'),
            ]);
        }
    }
}
add_action('bricks/form/submit', 'pro_bricks_form_to_webhook', 10, 1);