<?php
   /**
    * Function to Send Bricks Form Data to N8N Webhook using POST
    */
   function pro_bricks_form_to_webhook($form) {
       $data = $form->get_fields();
       $formId = $data['formId'];

       function cleanFormArray($array) {
           if (is_array($array)) {
               return implode(', ', array_filter($array));
           }
           return $array;
       }

       // Replace 'brxe-afmchd' with your actual form ID
       if ($formId == 'brxe-afmchd') {
           foreach ($data as $key => $value) {
               $data[$key] = cleanFormArray($value);
           }

           $webhook_url = "https://n8n.oviewdigital.com/webhook-test/cf06ffcf-cd4b-4eb9-9307-04175e5c0f2a";
           
           $curl = curl_init($webhook_url);
           curl_setopt($curl, CURLOPT_POST, true);
           curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
           curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
           curl_setopt($curl, CURLOPT_HTTPHEADER, [
               'Content-Type: application/x-www-form-urlencoded'
           ]);

           $result = curl_exec($curl);
           $http_status = curl_getinfo($curl, CURLINFO_HTTP_CODE);

           curl_close($curl);

           if ($http_status >= 200 && $http_status < 300) {
               $form->set_result([
                   'action' => 'webhook_submission',
                   'type'   => 'success',
                   'message' => esc_html__('Form submitted successfully', 'bricks'),
               ]);
           } else {
               $form->set_result([
                   'action' => 'webhook_submission',
                   'type'   => 'danger',
                   'message' => esc_html__('Webhook submission failed', 'bricks'),
               ]);
           }
       }
   }
   add_action('bricks/form/submit', 'pro_bricks_form_to_webhook', 10, 1);