<?php
/**
 * Function to Send Bricks Form Data to N8N Webhook using POST with debugging
 */
function pro_bricks_form_to_webhook($form) {
    $log_file = WP_CONTENT_DIR . '/debug_webhook.log';
    file_put_contents($log_file, "Function called at " . date('Y-m-d H:i:s') . "\n", FILE_APPEND);

    $data = $form->get_fields();
    $formId = $data['formId'];
    file_put_contents($log_file, "Form ID: $formId\n", FILE_APPEND);

    function cleanFormArray($array) {
        if (is_array($array)) {
            return implode(', ', array_filter($array));
        }
        return $array;
    }

    // Replace 'brxe-afmchd' with your actual form ID
    if ($formId == 'brxe-afmchd') {
        foreach ($data as $key => $value) {
            $data[$key] = cleanFormArray($value);
        }

        $webhook_url = "https://n8n.oviewdigital.com/webhook-test/cf06ffcf-cd4b-4eb9-9307-04175e5c0f2a";
        file_put_contents($log_file, "Webhook URL: $webhook_url\n", FILE_APPEND);
        
        $curl = curl_init($webhook_url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, [
            'Content-Type: application/x-www-form-urlencoded'
        ]);

        file_put_contents($log_file, "Sending data: " . print_r($data, true) . "\n", FILE_APPEND);

        $result = curl_exec($curl);
        $http_status = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        file_put_contents($log_file, "cURL result: $result\n", FILE_APPEND);
        file_put_contents($log_file, "HTTP status: $http_status\n", FILE_APPEND);

        if (curl_errno($curl)) {
            file_put_contents($log_file, "cURL error: " . curl_error($curl) . "\n", FILE_APPEND);
        }

        curl_close($curl);

        if ($http_status >= 200 && $http_status < 300) {
            $form->set_result([
                'action' => 'webhook_submission',
                'type'   => 'success',
                'message' => esc_html__('Form submitted successfully', 'bricks'),
            ]);
            file_put_contents($log_file, "Form submission successful\n", FILE_APPEND);
        } else {
            $form->set_result([
                'action' => 'webhook_submission',
                'type'   => 'danger',
                'message' => esc_html__('Webhook submission failed', 'bricks'),
            ]);
            file_put_contents($log_file, "Form submission failed\n", FILE_APPEND);
        }
    } else {
        file_put_contents($log_file, "Form ID did not match expected ID\n", FILE_APPEND);
    }
}
add_action('bricks/form/submit', 'pro_bricks_form_to_webhook', 10, 1);