<?php
function pro_bricks_form_to_webhook($form) {
    $data = $form->get_fields();
    $formId = $data['formId'];

    if ($formId == 'afmchd') {
        $webhook_url = "https://n8n.oviewdigital.com/webhook-test/cf06ffcf-cd4b-4eb9-9307-04175e5c0f2a";
        
        // Convert data to JSON
        $json_data = json_encode($data);

        $curl = curl_init($webhook_url);
        curl_setopt_array($curl, array(
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $json_data,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($json_data)
            ),
            // Skip SSL verification - Use with caution!
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_SSL_VERIFYHOST => false
        ));

        $result = curl_exec($curl);
        $http_status = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        if ($result === false) {
            $error = curl_error($curl);
            $form->set_result([
                'action' => 'my_custom_action',
                'type' => 'danger',
                'message' => esc_html__("Webhook failed: $error", 'bricks'),
            ]);
        } elseif ($http_status != 200) {
            $form->set_result([
                'action' => 'my_custom_action',
                'type' => 'danger',
                'message' => esc_html__("Webhook failed: HTTP status $http_status", 'bricks'),
            ]);
        } else {
            $form->set_result([
                'action' => 'my_custom_action',
                'type' => 'success',
                'message' => esc_html__('Message successfully sent. We will get back to you as soon as possible.', 'bricks'),
            ]);
        }

        curl_close($curl);
    }
}
add_action('bricks/form/custom_action', 'pro_bricks_form_to_webhook', 10, 1);