<?php

// Exit if accessed directly to prevent unauthorized access.
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

// Function to modify the main query and disable search queries
function disable_search( $query, $error = true ) {
    if ( is_search() ) {
        $query->is_search = false;
        $query->query_vars['s'] = false;
        $query->query['s'] = false;
        if ( $error == true ) {
            $query->is_404 = true;
        }
    }
}

// Hook the function to the 'parse_query' action
add_action( 'parse_query', 'disable_search' );

// Filter to disable the search form by returning null
add_filter( 'get_search_form', function( $a ) {
    return null;
});

// Function to unregister the search widget
function remove_search_widget() {
    unregister_widget( 'WP_Widget_Search' );
}

// Hook the function to the 'widgets_init' action
add_action( 'widgets_init', 'remove_search_widget' );